REM Quake console filter
REM reads Qconsole.log and converts
REM stats into HTML Netscape 3.0
REM Written by Richard Maxwell
REM current email Richard <maxwells@ihug.co.nz>
REM -------------------------------
REM 21/12/1997
REM -------------------------------

DECLARE FUNCTION getfilename$ (line$)
DECLARE FUNCTION date2days! ()
DECLARE SUB UpdatePlayer (killer$, killee$)
DECLARE FUNCTION GetPlayer% (pname$)
DECLARE SUB htmlfooter ()
DECLARE FUNCTION isPing$ (qline$)
DECLARE FUNCTION testSpecial% (qline$)
DECLARE SUB countIni ()
DECLARE SUB readIni ()
DECLARE SUB htmlheader ()
DECLARE FUNCTION htmlString$ (name$)
DECLARE FUNCTION testDeath% (qline$)
DECLARE FUNCTION countDeathIni% (file$)
DECLARE SUB readDeathIni (file$)
DECLARE SUB dumpStats ()
DECLARE FUNCTION isEnter% (qline$)
DECLARE FUNCTION isLevel% (qline$)
DECLARE FUNCTION testSuc% (qline$)
DECLARE SUB readSucIni (file$)
DECLARE FUNCTION countSucIni% (file$)
DECLARE FUNCTION istalking% (qline$)
DECLARE FUNCTION CountLevels% (file$)
DECLARE FUNCTION WhichPlayer% (test$)
DECLARE FUNCTION qwistalking% (qline$)
DECLARE FUNCTION testShowLine% (qline$)

CONST TRUE = 1
CONST FALSE = 0

COMMON SHARED pfound%
COMMON SHARED maxplayer%
COMMON SHARED readstats%
COMMON SHARED maxfilters%
COMMON SHARED clevel%
COMMON SHARED tlevel%
COMMON SHARED days!

COMMON SHARED flags%

COMMON SHARED numweapons%
COMMON SHARED numkfilters%
COMMON SHARED numsufilters%
COMMON SHARED numspfilters%
COMMON SHARED numtypesp%
COMMON SHARED numslfilters%        'number of showline filters

COMMON SHARED ofname$

COMMON SHARED bodytag$              'HTML body tag for generated pages

REM file handles

COMMON SHARED playerdata%
COMMON SHARED killdata%
COMMON SHARED tempdata%
COMMON SHARED logfile%
COMMON SHARED showline%

killdata% = 255
tempdata% = 254
playerdata% = 128
logfile% = 10
showline% = 253

REM file hadle 1 used for qconsole.log
REM file handle 2 used to output html


maxplayer% = 100
maxfilter% = 3

numweapons% = 0
numkfilters% = 0
numsufilters% = 0
numspfilters% = 0
numtypesp% = 0
numslfilters% = 0

REM flags% = 1 + 2 + 0 + 8 + 16 + 32 + 64 + 128 + 256 + 512
REM bit 1 - skip repeats
REM bit 2 - print out leftover file
REM bit 3 - print out any talking going on
REM bit 4 - print out weapon report
REM bit 5 - print out total kill report
REM bit 6 - print out special filters
REM bit 7 - print out awards stats
REM bit 8 - print out rankings (needs total kill report)
REM bit 9 - Add to overall player stats
REM bit10 - Use showline filters (anything containing the string is shown)

REM -------------init-------------
version$ = "1.05"
progdate$ = "21/12/1997"


line$ = UCASE$(COMMAND$)
IF INSTR(line$, " -H") > 0 OR INSTR(line$, " /H") > 0 OR INSTR(line$, " /?") > 0 THEN
PRINT "Quake Console Filter - By Richard Maxwell - "; progdate$; " ("; version$; ")"
PRINT "------------------------------------------------------------"
PRINT "Command syntax: CONREAD <file>"
PRINT "where <file> is the name of the quake console file."
PRINT "conread.ini must also be in the same directory as conread"
END
END IF


days! = date2days

ON ERROR GOTO ErrorHandler

CLS

CALL countIni

DIM SHARED playern(maxplayer%, 1) AS STRING
DIM SHARED players(maxplayer%, 3) AS LONG


DIM SHARED playstat(maxfilter%, numweapons%, maxfilter%) AS INTEGER
DIM SHARED numfilter(maxfilter%) AS INTEGER

numfilter(0) = numsufilters%
numfilter(1) = numkfilters%
numfilter(2) = numspfilters%

DIM SHARED sucfilters(numfilter(0)) AS STRING
DIM SHARED sucfilterw(numfilter(0)) AS INTEGER

DIM SHARED weaponame(numweapons%) AS STRING

DIM SHARED dfilterm(numfilter(1)) AS STRING
DIM SHARED dfiltere(numfilter(1)) AS STRING
DIM SHARED dfilterw(numfilter(1)) AS INTEGER
DIM SHARED dfilterr(numfilter(1)) AS INTEGER        'checks to see if have to reverse killer/killee

IF (flags% AND 32) = 32 THEN

DIM SHARED spfilters(numfilter(2)) AS STRING
DIM SHARED spfilterw(numfilter(2)) AS INTEGER

DIM SHARED spname(numtypesp%) AS STRING
DIM SHARED playspec(maxfilter%, numtypesp%) AS INTEGER

END IF

IF (flags% AND 512) = 512 THEN

DIM SHARED slfilters(numslfilters%) AS STRING           ' showline filters

END IF

REM -----types------

TYPE PlayerStats
 Handle AS STRING * 20
 Kills AS LONG
 deaths AS LONG
 Skill AS LONG
 LastSeen AS LONG
END TYPE

DIM SHARED FileBuffer AS PlayerStats
DIM SHARED Player1 AS PlayerStats
DIM SHARED Player2 AS PlayerStats
DIM SHARED TempPlayer AS PlayerStats

REM ------end of types-------

CALL readIni

wtemp% = 4

IF (flags% AND 8) = 8 THEN DIM SHARED wstats(numweapons%, wtemp%) AS INTEGER
IF (flags% AND 16) = 16 THEN DIM SHARED mstats(7) AS INTEGER
IF (flags% AND 32) = 32 THEN DIM SHARED sstats(numtypesp%) AS INTEGER
                                                                
IF (flags% AND 8) = 8 THEN DIM SHARED wstatsn(numweapons%, wtemp%) AS STRING
IF (flags% AND 16) = 16 THEN DIM SHARED mstatsn(7) AS STRING
IF (flags% AND 32) = 32 THEN DIM SHARED sstatsn(numtypesp%) AS STRING


cline$ = UCASE$(MID$(COMMAND$, INSTR(COMMAND$, " ") + 1))
IF cline$ <> "" THEN logfile$ = cline$ ELSE logfile$ = "qconsole.log"

IF logfile$ <> "qconsole.log" THEN ofname$ = getfilename$(logfile$)
IF ofname$ = "" THEN ofname$ = "level"

readstats% = FALSE

tlevel% = CountLevels(logfile$)
DIM SHARED leveln(tlevel%) AS STRING
DIM SHARED levelp(tlevel%) AS INTEGER

REM ----------- first pass --------------

LOCATE 1, 1
PRINT "Quake Console Filter - By Richard Maxwell - "; progdate$; " ("; version$; ")"
PRINT "------------------------------------------------------------"
PRINT "Processing file >"; logfile$; "<"
t = TIMER

pfound% = 0
clevel% = -1

OPEN logfile$ FOR INPUT AS #1


DO WHILE NOT EOF(1)

LINE INPUT #1, line$

skip = FALSE

IF line$ <> "" THEN

skip = isLevel(line$)
IF skip THEN LOCATE 9, 1: PRINT "Counting Players on level :"; clevel%; "/ "; tlevel%

IF clevel% > -1 THEN

line$ = isPing(line$)
IF skip = FALSE THEN skip = istalking(line$)
IF skip = FALSE THEN skip = isEnter(line$)
IF skip = FALSE THEN skip = testDeath(line$)
IF skip = FALSE THEN skip = testSuc(line$)
IF skip = FALSE THEN skip = testSpecial(line$)

END IF
END IF

LOOP


levelp(clevel%) = pfound%

CLOSE #1

REM ------------ last pass-------------

SHELL "md html"
SHELL "md plrdata"

CLS


IF (flags% AND 256) > 0 THEN OPEN "plrdata\players.dat" FOR RANDOM AS #playerdata% LEN = LEN(FileBuffer)

LOCATE 1, 1
PRINT "Quake Console Filter - By Richard Maxwell - "; progdate$; " ("; version$; ")"
PRINT "------------------------------------------------------------"
PRINT "Processing file >"; logfile$; "<"

readstats% = 2
clevel% = -1
pfound% = 0

OPEN logfile$ FOR INPUT AS #1
IF (flags% AND 2) > 0 THEN OPEN "html\" + ofname$ + "OUT.txt" FOR OUTPUT AS #logfile%

DO WHILE NOT EOF(1)

LINE INPUT #1, line$

skip = FALSE

IF line$ <> "" THEN

skip = isLevel(line$)

IF clevel% > -1 THEN

IF skip THEN
IF clevel% > 0 THEN CALL dumpStats: CLOSE readstats%
outfile$ = "html\" + ofname$ + RIGHT$(STR$(clevel% + 1), LEN(STR$(clevel% + 1)) - 1) + ".htm"
OPEN outfile$ FOR OUTPUT AS #readstats%
CALL htmlheader
pfound% = 0

ERASE playstat

IF (flags% AND 8) = 8 THEN REDIM SHARED wstatsn(numweapons%, wtemp%) AS STRING
IF (flags% AND 8) = 8 THEN REDIM SHARED wstats(numweapons%, wtemp%) AS INTEGER
IF (flags% AND 16) = 16 THEN ERASE mstats
IF (flags% AND 16) = 16 THEN ERASE mstatsn
IF (flags% AND 32) = 32 THEN REDIM SHARED sstats(numtypesp%) AS INTEGER
IF (flags% AND 32) = 32 THEN REDIM SHARED sstatsn(numtypesp%) AS STRING

IF (flags% AND 512) = 512 THEN
IF clevel% > 0 THEN CLOSE showline%
OPEN "showline.tmp" FOR OUTPUT AS #showline%
END IF

REDIM SHARED playern(levelp(clevel%), 1) AS STRING
REDIM SHARED players(levelp(clevel%), 3) AS LONG
REDIM SHARED playstat(levelp(clevel%), numweapons%, levelp(clevel%)) AS INTEGER
REDIM SHARED playspec(levelp(clevel%), numtypesp%) AS INTEGER

linecount = 0

END IF

linecount = linecount + 1

line$ = isPing(line$)
IF skip = FALSE THEN skip = istalking(line$)
IF skip = FALSE THEN skip = isEnter(line$)
IF skip = FALSE THEN skip = testDeath(line$)
IF skip = FALSE THEN skip = testSuc(line$)
IF skip = FALSE THEN skip = testSpecial(line$)
IF skip = FALSE THEN skip = testShowLine(line$)
IF skip = FALSE THEN skip = qwistalking(line$)

IF skip = FALSE THEN
IF (flags% AND 2) > 0 THEN PRINT #logfile%, line$
ELSE

LOCATE (clevel% MOD 16) + 4, 1
PRINT leveln$(clevel%); " - line:"; linecount; STRING$(10, " ")
END IF


END IF
END IF

LOOP

clevel% = clevel% + 1: CALL dumpStats: CLOSE readstats%
CLOSE #logfile%
IF flags% AND 256 > 0 THEN CLOSE playerdata%

CLS
LOCATE 1, 1
PRINT "Quake Console Filter - By Richard Maxwell - "; progdate$; " ("; version$; ")"
PRINT "------------------------------------------------------------"
PRINT
PRINT "DONE! (With timer value of :"; TIMER - t; ")"

CLOSE
IF (flags% AND 16) > 0 THEN KILL "killdata.tmp"

IF (flags% AND 128) > 0 THEN KILL "tempdata.tmp"

IF (flags% AND 512) > 0 THEN KILL "showline.tmp"

END

REM -------error handling--------

ErrorHandler:
   IF ERR = 53 THEN
      CLOSE
      IF logfile$ = "" THEN PRINT "Cannot find CONREAD.INI" ELSE PRINT ; "File "; UCASE$(logfile$); " not found."
      END
   ELSE
      CLOSE
      PRINT "Unrecoverable error--"; ERR
      END
   END IF

SUB countIni

numweapons% = 0
numkfilters% = 0
numsufilters% = 0
numspfilters% = 0

OPEN "conread.ini" FOR INPUT AS #1

rline$ = ""

REM --------------flags-----------------

DO WHILE (NOT EOF(1)) AND INSTR(rline$, "flags=") = 0

LINE INPUT #1, rline$

LOOP

IF INSTR(rline$, "flags") = 0 THEN PRINT "ERROR IN READCON.INI : Flag varible is not specified.": END

flags% = VAL(MID$(rline$, INSTR(rline$, "=") + 1))


REM -----------------weapons------------------


DO WHILE (NOT EOF(1)) AND INSTR(rline$, "****weapons") = 0

LINE INPUT #1, rline$

LOOP

IF INSTR(rline$, "****weapons") = 0 THEN PRINT "ERROR IN READCON.INI : No weapons have been defined.": END

DO WHILE (NOT EOF(1)) AND INSTR(rline$, "*****") = 0

INPUT #1, rline$
IF LEFT$(rline$, 5) = "-----" THEN numweapons% = numweapons% + 1
LOOP

IF EOF(1) THEN PRINT "ERROR IN READCON.INI : Missing ***** after weapons.": END

REM --------------------suicide filters----------------

DO WHILE (NOT EOF(1)) AND INSTR(rline$, "****sucs") = 0

LINE INPUT #1, rline$

LOOP

IF INSTR(rline$, "****sucs") = 0 THEN PRINT "ERROR IN READCON.INI : No suicide filters have been defined.": END

DO WHILE (NOT EOF(1)) AND INSTR(rline$, "*****") = 0

INPUT #1, rline$

IF LEFT$(rline$, 5) = "-----" OR rline$ = "" OR LEFT$(rline$, 1) = "#" OR rline$ = "*****" THEN
ELSE
numsufilters% = numsufilters% + 1
END IF

LOOP

IF EOF(1) THEN PRINT "ERROR IN READCON.INI : Missing ***** after Suicides.": END

REM ----------------death filters-------------

DO WHILE (NOT EOF(1)) AND INSTR(rline$, "****deaths") = 0

LINE INPUT #1, rline$

LOOP

IF INSTR(rline$, "****deaths") = 0 THEN PRINT "ERROR IN READCON.INI : No death filters have been defined.": END

DO WHILE (NOT EOF(1)) AND INSTR(rline$, "*****") = 0

LINE INPUT #1, rline$

IF LEFT$(rline$, 5) = "-----" OR rline$ = "" OR LEFT$(rline$, 1) = "#" OR rline$ = "*****" THEN
ELSE
numkfilters% = numkfilters% + 1
END IF

LOOP

IF EOF(1) THEN PRINT "ERROR IN READCON.INI : Missing ***** after Deaths.": END

numkfilters% = numkfilters% / 2

REM -------------special filters------------

IF (flags% AND 32) = 32 THEN

DO WHILE (NOT EOF(1)) AND INSTR(rline$, "****special") = 0

LINE INPUT #1, rline$

LOOP

IF INSTR(rline$, "****special") = 0 THEN PRINT "ERROR IN READCON.INI : No special filters have been defined.": END

DO WHILE (NOT EOF(1)) AND INSTR(rline$, "*****") = 0

LINE INPUT #1, rline$

IF LEFT$(rline$, 5) = "-----" THEN numtypesp% = numtypesp% + 1
IF LEFT$(rline$, 5) = "-----" OR rline$ = "" OR LEFT$(rline$, 1) = "#" OR rline$ = "*****" THEN
ELSE
numspfilters% = numspfilters% + 1
END IF

LOOP

IF EOF(1) AND rline$ <> "*****" THEN PRINT "ERROR IN READCON.INI : Missing ***** after special filters.": END

END IF

REM -------------showline filters------------

IF (flags% AND 512) = 512 THEN

DO WHILE (NOT EOF(1)) AND INSTR(rline$, "****showline") = 0

LINE INPUT #1, rline$

LOOP

IF INSTR(rline$, "****showline") = 0 THEN PRINT "ERROR IN READCON.INI : No special filters have been defined.": END

DO WHILE (NOT EOF(1)) AND INSTR(rline$, "*****") = 0

LINE INPUT #1, rline$

IF rline$ = "" OR LEFT$(rline$, 1) = "#" OR rline$ = "*****" THEN
ELSE
numslfilters% = numslfilters% + 1
END IF

LOOP

IF EOF(1) AND rline$ <> "*****" THEN PRINT "ERROR IN READCON.INI : Missing ***** after special filters.": END

END IF


CLOSE #1

LOCATE 4, 1

PRINT "Flag has been set to "; flags%
PRINT "Found "; numweapons%; " Weapon(s)."
PRINT "Found "; numsufilters%; " suicide filter(s)."
PRINT "Found "; numkfilters%; " death filter(s)."
PRINT "Found "; numspfilters%; " special filter(s)."
PRINT "Found "; numslfilters%; " showline filter(s)."

IF numspfilters% = 0 THEN flags% = (flags% AND 65503)

IF (flags% AND 16) = 0 THEN flags% = (flags% AND 65407)

END SUB

DEFINT A-Z
FUNCTION CountLevels (file$)

OPEN file$ FOR INPUT AS #1

count = 0

DO WHILE NOT EOF(1)

LINE INPUT #1, cline$

IF INSTR(cline$, STRING$(10, CHR$(30))) > 1 THEN count = count + 1

LOOP

IF count = 0 THEN count = 1

CLOSE #1

CountLevels = count

END FUNCTION

DEFSNG A-Z
FUNCTION date2days!
year = VAL(RIGHT$(DATE$, 4))
month = VAL(LEFT$(DATE$, 2))
day = VAL(MID$(DATE$, 4, 2))
date2days! = day + (31 * (month - 1)) + (366 * (year - 1997))
END FUNCTION

DEFINT A-Z
SUB dumpStats

PRINT #readstats%, "</FONT></PRE><CENTER>"

REM-------------names-----------

IF levelp(clevel% - 1) = 0 THEN

PRINT #readstats%, "<A NAME=players></A>"
PRINT #readstats%, "<A NAME=total></A>"
PRINT #readstats%, "<A NAME=weapon></A>"
PRINT #readstats%, "<A NAME=special></A>"
PRINT #readstats%, "<A NAME=awards></A>"
PRINT #readstats%, "<A NAME=rankings></A>"
PRINT #readstats%, "<A NAME=showline</A>"


PRINT #readstats%, "<P>nothing interesting happened on this level</P>"

ELSE

PRINT #readstats%, "<HR WIDTH=100%>"
PRINT #readstats%, "<A NAME=players></A>"
PRINT #readstats%, "<H2 ALIGN=CENTER>"; levelp(clevel% - 1); "Players</H2>"

PRINT #readstats%, "<PRE>"

temp1! = 0
temp2! = 0
temp2! = 0
FOR kilr% = 1 TO levelp(clevel% - 1)

IF players(kilr%, 1) > 0 THEN
mean! = CINT(players(kilr%, 1) / players(kilr%, 2))
IF mean! < 200 THEN
PRINT #readstats%, playern(kilr%, 1); " (<FONT COLOR=#8080FF>"; MID$(STR$(mean!), 2); "</FONT>)"
ELSE
IF mean! > 499 THEN
PRINT #readstats%, playern(kilr%, 1); " (<FONT COLOR=#FF0000>"; MID$(STR$(mean!), 2); "</FONT>)"
ELSE
PRINT #readstats%, playern(kilr%, 1); " ("; MID$(STR$(mean!), 2); ")"
END IF
END IF

temp1! = temp1! + 1
temp2! = temp2! + CINT(players(kilr%, 1) / players(kilr%, 2))
IF CINT(players(kilr%, 1) / players(kilr%, 2)) > 1000 THEN
sumf! = sumf! + 1000
ELSE
sumf! = sumf! + CINT(players(kilr%, 1) / players(kilr%, 2))
END IF


ELSE
PRINT #readstats%, playern(kilr%, 1)
END IF
NEXT
IF temp2! > 0 THEN
mean! = CINT(temp2! / temp1!)
mmean! = CINT(sumf! / temp1!)
sumf! = temp1!
sumdev! = 0
msumdev! = 0
FOR kilr% = 1 TO levelp(clevel% - 1)

IF players(kilr%, 1) > 0 THEN
temp1! = CINT(players(kilr%, 1) / players(kilr%, 2))
temp2! = temp1!
IF temp2! > 1000 THEN temp2! = 1000
sumdev! = sumdev! + (temp1! - mean!) ^ 2
msumdev! = msumdev! + (temp2! - mmean!) ^ 2
END IF
NEXT
stdev% = CINT(SQR(sumdev! / sumf!))
mstdev% = CINT(SQR(msumdev! / sumf!))

PRINT #readstats%, "-"
PRINT #readstats%, "Average ping :"; mean!; " ("; MID$(STR$(mmean!), 2); ")"
PRINT #readstats%, "Std Deviation"; stdev%; " ("; MID$(STR$(mstdev%), 2); ")"

END IF


PRINT #readstats%, " "

PRINT #readstats%, "</PRE>"

REM -----------showlines--------------------

IF (flags% AND 512) = 512 THEN

PRINT #readstats%, "<HR WIDTH=100%>"
PRINT #readstats%, "<A NAME=showline></A>"
PRINT #readstats%, "<H2>Important Messages</H2>"
PRINT #readstats%, "<PRE>"

CLOSE #showline%
OPEN "showline.tmp" FOR INPUT AS #showline%

DO WHILE NOT EOF(showline%)

LINE INPUT #showline%, temp$
PRINT #readstats%, htmlString(temp$)
LOOP

PRINT #readstats%, "</PRE>"
END IF

REM -----------total kills table------------

IF (flags% AND 16) > 0 THEN

OPEN "killdata.tmp" FOR OUTPUT AS #killdata%

PRINT #readstats%, "<HR WIDTH=100%>"
PRINT #readstats%, "<A NAME=total></A>"
PRINT #readstats%, "<H2>Level Statistics</H2>"

PRINT #readstats%, "<TABLE BORDER=1 >"
PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TH><FONT COLOR=#8080FF>Name</FONT></TH>"

FOR kilr% = 1 TO levelp(clevel% - 1)
PRINT #readstats%, "<TH>" + RIGHT$(STR$(kilr%), LEN(STR$(kilr%)) - 1) + " " + "</TH>"
NEXT
PRINT #readstats%, "<TH><FONT COLOR=#8080FF>Total kills</FONT></TH>"
PRINT #readstats%, "<TH><FONT COLOR=#8080FF>Frag Count</FONT></TH>"
PRINT #readstats%, "<TH><FONT COLOR=#8080FF>Rank</FONT></TH>"

PRINT #readstats%, "</TR>"

allgibs% = 0
allsucs% = 0
alldeaths% = 0
mostsucs% = 0
mostsuc$ = ""
mstats(1) = 1000
mstats(4) = mstats(1)
mstats(5) = mstats(1)

FOR kilr% = 1 TO levelp(clevel% - 1)

PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TD>" + RIGHT$(STR$(kilr%), LEN(STR$(kilr%)) - 1) + " " + playern(kilr%, 1) + "</TD>"

totalgibs% = 0
temp2! = 0

FOR kile% = 1 TO levelp(clevel% - 1)

gibs% = 0
deaths% = 0

FOR weap% = 1 TO numweapons%

gibs% = gibs% + playstat(kilr%, weap%, kile%)
deaths% = deaths% + playstat(kile%, weap%, kilr%)

NEXT

IF kilr% = kile% THEN
gibs% = gibs% + players(kilr%, 0)
tsucs% = gibs%
deaths% = deaths% + players(kilr%, 0)
PRINT #readstats%, "<TD><FONT COLOR=#FF0000>"; RIGHT$(STR$(gibs%), LEN(STR$(gibs%)) - 1); "</FONT></TD>"
IF gibs% = mostsucs% THEN mostsuc$ = mostsuc$ + ", " + playern(kilr%, 1)
IF gibs% > mostsucs% THEN mostsucs% = gibs%: mostsuc$ = playern(kilr%, 1)
ELSE
PRINT #readstats%, "<TD>"; RIGHT$(STR$(gibs%), LEN(STR$(gibs%)) - 1); "</TD>"
END IF

totalgibs% = totalgibs% + gibs%
temp2! = temp2! + deaths%

NEXT

allgibs% = allgibs% + totalgibs%

'modifier! = 1
'IF (flags% AND 128) = 128 AND players(kilr%, 1) > 0 THEN
'diff% = CINT(players(kilr%, 1) / players(kilr%, 2)) - mmean!
'IF ABS(diff%) > mstdev% THEN
'IF ABS(diff%) > 2 * (mstdev%) THEN
'IF SGN(diff%) = -1 THEN modifier! = .5 ELSE modifier! = 2
'ELSE
'IF SGN(diff%) = -1 THEN modifier! = .75 ELSE modifier! = 1.33
'END IF
'END IF
'END IF

deaths% = temp2!
temp2! = totalgibs% - deaths%
 
IF temp2! = mstats(0) THEN mstatsn(0) = mstatsn(0) + ", " + playern(kilr%, 1)
IF temp2! > mstats(0) THEN mstats(0) = temp2!: mstatsn(0) = playern(kilr%, 1)

IF temp2! = mstats(1) THEN mstatsn(1) = mstatsn(1) + ", " + playern(kilr%, 1)
IF temp2! < mstats(1) THEN mstats(1) = temp2!: mstatsn(1) = playern(kilr%, 1)

IF totalgibs% = mstats(3) THEN mstatsn(3) = mstatsn(3) + ", " + playern(kilr%, 1)
IF totalgibs% > mstats(3) THEN mstats(3) = totalgibs%: mstatsn(3) = playern(kilr%, 1)

IF deaths% = mstats(6) THEN mstatsn(6) = mstatsn(6) + ", " + playern(kilr%, 1)
IF deaths% > mstats(6) THEN mstats(6) = deaths%: mstatsn(6) = playern(kilr%, 1)

IF totalgibs% = mstats(4) THEN mstatsn(4) = mstatsn(4) + ", " + playern(kilr%, 1)
IF totalgibs% < mstats(4) THEN mstats(4) = totalgibs%: mstatsn(4) = playern(kilr%, 1)
  
IF deaths% = mstats(5) THEN mstatsn(5) = mstatsn(5) + ", " + playern(kilr%, 1)
IF deaths% < mstats(5) THEN mstats(5) = deaths%: mstatsn(5) = playern(kilr%, 1)

IF (deaths% + totalgibs%) = 0 THEN temp2! = 0 ELSE temp2! = CINT(100 * (totalgibs% / (deaths% + totalgibs%)))

IF temp2! = mstats(2) THEN mstatsn(2) = mstatsn(2) + ", " + playern(kilr%, 1)
IF temp2! > mstats(2) THEN mstats(2) = temp2!: mstatsn(2) = playern(kilr%, 1)


PRINT #readstats%, "<TD><FONT COLOR=#FF8000>"; MID$(STR$(totalgibs%), 2); "</FONT></TD>"
PRINT #readstats%, "<TD><FONT COLOR=#FF8000>"; (totalgibs% - (2 * tsucs%)); "</FONT></TD>"
PRINT #readstats%, "<TD><FONT COLOR=#FF8000>"; (totalgibs% - deaths%); "</FONT></TD>"
PRINT #killdata%, playern(kilr%, 1)
PRINT #killdata%, totalgibs%
PRINT #killdata%, deaths%

allsucs% = allsucs% + tsucs%

PRINT #readstats%, "</TR>"

NEXT

PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TH><FONT COLOR=#8080FF>Total Deaths</FONT></TH>"

FOR kilr% = 1 TO levelp(clevel% - 1)

totaldeaths% = 0

FOR kile% = 1 TO levelp(clevel% - 1)

deaths% = 0

FOR weap% = 1 TO numweapons%
deaths% = deaths% + playstat(kile%, weap%, kilr%)
NEXT
totaldeaths% = totaldeaths% + deaths%
NEXT

totaldeaths% = totaldeaths% + players(kilr%, 0)

alldeaths% = alldeaths% + totaldeaths%

PRINT #readstats%, "<TD><FONT COLOR=#FF8000>"; RIGHT$(STR$(totaldeaths%), LEN(STR$(totaldeaths%)) - 1); "</FONT></TD>"

NEXT

PRINT #readstats%, "<TH><FONT COLOR=#8080FF>"; RIGHT$(STR$(allgibs%), LEN(STR$(allgibs%)) - 1); "</FONT></TH>"
PRINT #readstats%, "<TH><FONT COLOR=#8080FF>"; (allgibs% - (2 * allsucs%)); "</FONT></TH>"

PRINT #readstats%, "</TR>"


PRINT #readstats%, "</TABLE>"



IF mstats(6) = 0 THEN

PRINT #readstats%, "<PRE>"
PRINT #readstats%, "Nobody killed anyone, How boring!"
PRINT #readstats%, "</PRE>"

END IF

CLOSE #killdata%

END IF


REM --------ranking tables--------

REM can only do if flags 128 and 16 are set (total kills and rank tables)

IF (flags% AND 144) = 144 THEN

PRINT #readstats%, "<HR WIDTH=100%>"
PRINT #readstats%, "<A NAME=rankings></A>"
PRINT #readstats%, "<H2>Player Rankings</H2>"

IF mstats(6) < 1 THEN

PRINT #readstats%, "<P>No one killed anyone, ergo - noone can be ranked</P>"

ELSE

PRINT #readstats%, "<TABLE BORDER=0 WIDTH=100%>"
PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TD ALIGN=CENTER WIDTH=50%>"

REM -----RANK-----

OPEN "tempdata.tmp" FOR OUTPUT AS #tempdata%
temp1! = 10000
temp2! = 0
temp$ = ""
total% = 0

OPEN "killdata.tmp" FOR INPUT AS #killdata%

DO WHILE (NOT EOF(killdata%))
LINE INPUT #killdata%, temp$
INPUT #killdata%, totalgibs%, deaths%
IF (totalgibs% - deaths%) > total% THEN total% = totalgibs% - deaths%
IF (totalgibs% - deaths%) < temp1! THEN temp1! = totalgibs% - deaths%
LOOP

temp2! = temp1!

CLOSE #killdata%

DO WHILE temp1! <> 1

OPEN "killdata.tmp" FOR INPUT AS #killdata%

DO WHILE NOT EOF(killdata%)

LINE INPUT #killdata%, temp$
INPUT #killdata%, totalgibs%, deaths%

IF (totalgibs% - deaths%) = total% THEN PRINT #tempdata%, temp$: PRINT #tempdata%, (totalgibs% - deaths%)
IF (totalgibs% - deaths%) > temp2! AND (totalgibs% - deaths%) < total% THEN temp2! = (totalgibs% - deaths%)

LOOP

CLOSE #killdata%

IF total% = temp2! THEN temp1! = 1 ELSE total% = temp2!: temp2! = temp1!

LOOP
CLOSE #tempdata%

PRINT #readstats%, "<FONT COLOR=#8080FF><FONT SIZE=+1>Most Worthy<BR></FONT>"
PRINT #readstats%, "<FONT SIZE=-2>( Kills - deaths )</FONT></FONT>"
PRINT #readstats%, "<P>-</P>"
PRINT #readstats%, "<TABLE BORDER=1 >"
PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TH><FONT COLOR=#8080FF>Name</FONT></TH>"
PRINT #readstats%, "<TH>Rank</TH>"
PRINT #readstats%, "</TR>"

OPEN "tempdata.tmp" FOR INPUT AS #tempdata%
DO WHILE NOT EOF(tempdata%)

LINE INPUT #tempdata%, temp$
INPUT #tempdata%, temp1!
PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TD>"; temp$; "</TD>"
PRINT #readstats%, "<TH>"; temp1!; "</TH>"
PRINT #readstats%, "</TR>"
LOOP
CLOSE #tempdata%
PRINT #readstats%, "</TABLE>"
PRINT #readstats%, "-"
PRINT #readstats%, "</TD>"

REM -----effency-----

PRINT #readstats%, "<TD ALIGN=CENTER WIDTH=50%>"

OPEN "tempdata.tmp" FOR OUTPUT AS #tempdata%
temp1! = 100
temp2! = 0
temp$ = ""
total% = 0

OPEN "killdata.tmp" FOR INPUT AS #killdata%

DO WHILE (NOT EOF(killdata%))
LINE INPUT #killdata%, temp$
INPUT #killdata%, totalgibs%, deaths%

IF totalgibs% + deaths% > 0 THEN

IF CINT(100 * totalgibs% / (totalgibs% + deaths%)) > total% THEN total% = CINT(100 * totalgibs% / (totalgibs% + deaths%))

END IF

LOOP

CLOSE #killdata%

DO WHILE temp2! > -1

OPEN "killdata.tmp" FOR INPUT AS #killdata%

DO WHILE NOT EOF(killdata%)
LINE INPUT #killdata%, temp$
INPUT #killdata%, totalgibs%, deaths%

IF totalgibs% + deaths% = 0 THEN temp1! = 0 ELSE temp1! = CINT(100 * totalgibs% / (totalgibs% + deaths%))

IF temp1! = total% THEN PRINT #tempdata%, temp$: PRINT #tempdata%, temp1!
IF temp1! > temp2! AND temp1! < total% THEN temp2! = temp1!

LOOP

CLOSE #killdata%

IF total% = temp2! THEN temp2! = -1 ELSE total% = temp2!: temp2! = 0

LOOP
CLOSE #tempdata%

PRINT #readstats%, "<FONT COLOR=#8080FF><FONT SIZE=+1>Most Efficient<BR></FONT>"
PRINT #readstats%, "<FONT SIZE=-2>Kills<BR>"
PRINT #readstats%, "--------------<BR>"
PRINT #readstats%, "( Kills + Deaths )</FONT></FONT>"
PRINT #readstats%, "<P>-</P>"


PRINT #readstats%, "<TABLE BORDER=1 >"
PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TH><FONT COLOR=#8080FF>Name</FONT></TH>"
PRINT #readstats%, "<TH>Efficiency</TH>"
PRINT #readstats%, "</TR>"

OPEN "tempdata.tmp" FOR INPUT AS #tempdata%
DO WHILE NOT EOF(tempdata%)

LINE INPUT #tempdata%, temp$
INPUT #tempdata%, temp1!
PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TD>"; temp$; "</TD>"
PRINT #readstats%, "<TH>"; temp1!; "%</TH>"
PRINT #readstats%, "</TR>"
LOOP
CLOSE #tempdata%
PRINT #readstats%, "</TABLE>"
PRINT #readstats%, "<P>-</P>"
PRINT #readstats%, "</TD>"
PRINT #readstats%, "</TR>"


REM -----kills-----

PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TD ALIGN=CENTER WIDTH=50%>"

OPEN "tempdata.tmp" FOR OUTPUT AS #tempdata%
temp1! = 100
temp2! = 0
temp$ = ""
total% = 0

OPEN "killdata.tmp" FOR INPUT AS #killdata%

DO WHILE (NOT EOF(killdata%))
LINE INPUT #killdata%, temp$
INPUT #killdata%, totalgibs%, deaths%
IF totalgibs% > total% THEN total% = totalgibs%

LOOP

CLOSE #killdata%

DO WHILE temp2! > -1

OPEN "killdata.tmp" FOR INPUT AS #killdata%

DO WHILE NOT EOF(killdata%)
LINE INPUT #killdata%, temp$
INPUT #killdata%, totalgibs%, deaths%

IF totalgibs% = total% THEN PRINT #tempdata%, temp$: PRINT #tempdata%, totalgibs%
IF totalgibs% > temp2! AND totalgibs% < total% THEN temp2! = totalgibs%

LOOP

CLOSE #killdata%

IF total% = temp2! THEN temp2! = -1 ELSE total% = temp2!: temp2! = 0

LOOP
CLOSE #tempdata%

PRINT #readstats%, "<FONT COLOR=#8080FF><FONT SIZE=+1>Top Killers<BR></FONT></FONT>"
PRINT #readstats%, "<P>-</P>"


PRINT #readstats%, "<TABLE BORDER=1 >"
PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TH><FONT COLOR=#8080FF>Name</FONT></TH>"
PRINT #readstats%, "<TH>Kills</TH>"
PRINT #readstats%, "</TR>"

OPEN "tempdata.tmp" FOR INPUT AS #tempdata%
DO WHILE NOT EOF(tempdata%)

LINE INPUT #tempdata%, temp$
INPUT #tempdata%, temp1!
PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TD>"; temp$; "</TD>"
PRINT #readstats%, "<TH>"; temp1!; "</TH>"
PRINT #readstats%, "</TR>"
LOOP
CLOSE #tempdata%
PRINT #readstats%, "</TABLE>"
PRINT #readstats%, "</TD>"

REM -----deaths-----

PRINT #readstats%, "<TD ALIGN=CENTER WIDTH=50%>"

OPEN "tempdata.tmp" FOR OUTPUT AS #tempdata%
temp1! = 100
temp2! = 0
temp$ = ""
total% = 0

OPEN "killdata.tmp" FOR INPUT AS #killdata%

DO WHILE (NOT EOF(killdata%))
LINE INPUT #killdata%, temp$
INPUT #killdata%, totalgibs%, deaths%
IF deaths% > total% THEN total% = deaths%

LOOP

CLOSE #killdata%

DO WHILE temp2! > -1

OPEN "killdata.tmp" FOR INPUT AS #killdata%

DO WHILE NOT EOF(killdata%)
LINE INPUT #killdata%, temp$
INPUT #killdata%, totalgibs%, deaths%

IF deaths% = total% THEN PRINT #tempdata%, temp$: PRINT #tempdata%, deaths%
IF deaths% > temp2! AND deaths% < total% THEN temp2! = deaths%

LOOP

CLOSE #killdata%

IF total% = temp2! THEN temp2! = -1 ELSE total% = temp2!: temp2! = 0

LOOP
CLOSE #tempdata%

PRINT #readstats%, "<FONT COLOR=#8080FF><FONT SIZE=+1>Top Killees<BR></FONT></FONT>"
PRINT #readstats%, "<P>-</P>"

PRINT #readstats%, "<TABLE BORDER=1 >"
PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TH><FONT COLOR=#8080FF>Name</FONT></TH>"
PRINT #readstats%, "<TH>Deaths</TH>"
PRINT #readstats%, "</TR>"

OPEN "tempdata.tmp" FOR INPUT AS #tempdata%
DO WHILE NOT EOF(tempdata%)

LINE INPUT #tempdata%, temp$
INPUT #tempdata%, temp1!
PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TD>"; temp$; "</TD>"
PRINT #readstats%, "<TH>"; temp1!; "</TH>"
PRINT #readstats%, "</TR>"
LOOP
CLOSE #tempdata%
PRINT #readstats%, "</TABLE>"
PRINT #readstats%, "</TD>"
PRINT #readstats%, "</TR>"

PRINT #readstats%, "</TABLE>"

END IF

REM ^^^ end of check to see if any deaths occured.

END IF

REM ^^^ end of ranking tables








REM ---------------weapon tables----------------


IF (flags% AND 8) > 0 THEN

PRINT #readstats%, "<A NAME=weapon></A>"

temp1! = 0
FOR weap% = 1 TO numweapons%
totaldeaths% = 0
FOR kilr% = 1 TO levelp(clevel% - 1)
deaths% = 0
FOR kile% = 1 TO levelp(clevel% - 1)
deaths% = deaths% + playstat(kile%, weap%, kilr%)
NEXT
totaldeaths% = totaldeaths% + deaths%
NEXT
temp1! = temp1! + totaldeaths%
NEXT

IF temp1! > 0 THEN

PRINT #readstats%, "<HR WIDTH=100%>"
PRINT #readstats%, "<H2>Weapon Statistics</H2>"

FOR weap% = 1 TO numweapons%

totaldeaths% = 0
FOR kilr% = 1 TO levelp(clevel% - 1)
deaths% = 0
FOR kile% = 1 TO levelp(clevel% - 1)
deaths% = deaths% + playstat(kile%, weap%, kilr%)
NEXT
totaldeaths% = totaldeaths% + deaths%
NEXT

IF totaldeaths% > 0 THEN

PRINT #readstats%, "<TABLE BORDER=1 >"
PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TH><FONT COLOR=#8080FF> " + weaponame(weap%) + "</FONT></TH>"

FOR kilr% = 1 TO levelp(clevel% - 1)
PRINT #readstats%, "<TH>" + RIGHT$(STR$(kilr%), LEN(STR$(kilr%)) - 1) + " " + "</TH>"
NEXT
PRINT #readstats%, "<TH><FONT COLOR=#8080FF>Total kills</FONT></TH>"
PRINT #readstats%, "</TR>"

totalgibs% = 0

FOR kilr% = 1 TO levelp(clevel% - 1)

PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TD>" + RIGHT$(STR$(kilr%), LEN(STR$(kilr%)) - 1) + " " + playern(kilr%, 1) + "</TD>"

gibs% = 0
temp1! = 0

FOR kile% = 1 TO levelp(clevel% - 1)

gibs% = gibs% + playstat(kilr%, weap%, kile%)
temp1! = temp1! + playstat(kile%, weap%, kilr%)

IF kilr% = kile% THEN
PRINT #readstats%, "<TD><FONT COLOR=#FF0000>"; playstat(kilr%, weap%, kile%); "</FONT></TD>"
temp2! = playstat(kilr%, weap%, kile%)
ELSE
PRINT #readstats%, "<TD>"; playstat(kilr%, weap%, kile%); "</TD>"
END IF

NEXT

totalgibs% = totalgibs% + gibs%

IF temp1! <> 0 OR gibs% <> 0 THEN

IF gibs% = wstats(weap%, 0) THEN wstatsn(weap%, 0) = wstatsn(weap%, 0) + ", " + playern(kilr%, 1)
IF gibs% > wstats(weap%, 0) THEN wstats(weap%, 0) = gibs%: wstatsn(weap%, 0) = playern(kilr%, 1)

IF temp2! > 0 THEN
IF temp2! = wstats(weap%, 2) THEN wstatsn(weap%, 2) = wstatsn(weap%, 2) + ", " + playern(kilr%, 1)
IF temp2! > wstats(weap%, 2) THEN wstats(weap%, 2) = temp2!: wstatsn(weap%, 2) = playern(kilr%, 1)
END IF

IF temp1! = wstats(weap%, 1) THEN wstatsn(weap%, 1) = wstatsn(weap%, 1) + ", " + playern(kilr%, 1)
IF temp1! > wstats(weap%, 1) THEN wstats(weap%, 1) = temp1!: wstatsn(weap%, 1) = playern(kilr%, 1)

IF (temp1! + gibs%) = 0 THEN temp2! = 0 ELSE temp2! = CINT(100 * (gibs% / (temp1! + gibs%)))

IF temp2! = wstats(weap%, 3) THEN wstatsn(weap%, 3) = wstatsn(weap%, 3) + ", " + playern(kilr%, 1)
IF temp2! > wstats(weap%, 3) THEN wstats(weap%, 3) = temp2!: wstatsn(weap%, 3) = playern(kilr%, 1)

END IF

PRINT #readstats%, "<TD><FONT COLOR=#FF8000>"; gibs%; "</FONT></TD>"

PRINT #readstats%, "</TR>"

NEXT

PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TH><FONT COLOR=#8080FF>Total Deaths</FONT></TH>"

totaldeaths% = 0

FOR kilr% = 1 TO levelp(clevel% - 1)

deaths% = 0

FOR kile% = 1 TO levelp(clevel% - 1)

deaths% = deaths% + playstat(kile%, weap%, kilr%)

NEXT

totaldeaths% = totaldeaths% + deaths%

PRINT #readstats%, "<TD><FONT COLOR=#FF8000>"; deaths%; "</FONT></TD>"

NEXT

PRINT #readstats%, "<TH><FONT COLOR=#8080FF>"; totaldeaths%; "</FONT></TH>"

PRINT #readstats%, "</TR>"

PRINT #readstats%, "</TABLE>"
PRINT #readstats%, "<PRE>"
PRINT #readstats%, " "
PRINT #readstats%, "</PRE>"

REM endif below belongs to the check as to we need this table
END IF

NEXT

END IF
REM ^^^ this end if to see wether we need tables at all?
END IF

REM ----------------special filters------------

IF (flags% AND 32) > 0 THEN

PRINT #readstats%, "<A NAME=special></A>"

temp2! = 0
FOR spec% = 0 TO numtypesp% - 1

FOR plr% = 1 TO levelp(clevel% - 1)
temp2! = temp2! + playspec(plr%, spec%)
NEXT
NEXT

IF temp2! > 0 THEN

PRINT #readstats%, "<HR WIDTH=100%>"
PRINT #readstats%, "<H2>Special Filter Statistics</H2>"
PRINT #readstats%, " "

temp1! = 0
temp2! = 0
PRINT #readstats%, "<TABLE BORDER=0 WIDTH=100%><TR>"

FOR spec% = 0 TO numtypesp% - 1

temp2! = 0
FOR plr% = 1 TO levelp(clevel% - 1)

IF temp2! < playspec(plr%, spec%) THEN
temp2! = playspec(plr%, spec%)
sstats(spec%) = temp2!
sstatsn(spec%) = playern(plr%, 1)
END IF

NEXT

IF temp2! > 0 THEN

total% = 0

PRINT #readstats%, "<TD ALIGN=CENTER WIDTH=50%>"
PRINT #readstats%, "<TABLE BORDER=1 >"
PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TH><FONT COLOR=#8080FF> " + spname(spec%) + "</FONT></TH>"
PRINT #readstats%, "<TH>Amount</TH>"
PRINT #readstats%, "</TR>"

REM using deaths% as a temp var - to do ranking
deaths% = 0

DO WHILE temp2! > 0

FOR plr% = 1 TO levelp(clevel% - 1)

IF playspec(plr%, spec%) = temp2! THEN

IF playspec(plr%, spec%) = sstats(spec%) AND sstatsn(spec%) <> playern(plr%, 1) THEN sstatsn(spec%) = sstatsn(spec%) + ", " + playern(plr%, 1)

PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TD>" + playern(plr%, 1) + "</TD>"
PRINT #readstats%, "<TH>" + RIGHT$(STR$(playspec(plr%, spec%)), LEN(STR$(playspec(plr%, spec%))) - 1) + "</TH>"

total% = total% + playspec(plr%, spec%)

ELSE
IF playspec(plr%, spec%) > deaths% AND playspec(plr%, spec%) < temp2! THEN deaths% = playspec(plr%, spec%)


'IF playspec(plr%, spec%) > 0 THEN
'PRINT #readstats%, "<TR>"
'PRINT #readstats%, "<TD>" + playern(plr%, 1) + "</TD>"
'PRINT #readstats%, "<TH>" + RIGHT$(STR$(playspec(plr%, spec%)), LEN(STR$(playspec(plr%, spec%))) - 1) + "</TH>"

'IF sstatsn(spec%) <> playern(plr%, 1) THEN
'IF playspec(plr%, spec%) <> 0 AND playspec(plr%, spec%) = sstats(spec%) THEN sstatsn(spec%) = sstatsn(spec%) + ", " + playern(plr%, 1)
'END IF


'total% = total% + playspec(plr%, spec%)
'END IF

END IF
REM ^^^ end if for ranking check

NEXT

temp2! = deaths%: deaths% = 0

LOOP

PRINT #readstats%, "</TR>"



temp1! = temp1! + 1

PRINT #readstats%, "<TR>"
PRINT #readstats%, "<TH><FONT COLOR=#8080FF>Total</FONT></TH>"
PRINT #readstats%, "<TH><FONT COLOR=#FF8000>" + RIGHT$(STR$(total%), LEN(STR$(total%)) - 1) + "</TH>"
PRINT #readstats%, "</TR>"

PRINT #readstats%, "</TABLE>"

PRINT #readstats%, "<PRE>"
PRINT #readstats%, "-"
PRINT #readstats%, "</PRE>"


PRINT #readstats%, "</TD>"

IF (temp1! MOD 2) = 0 THEN PRINT #readstats%, "</TR><TR>"

REM - testing for empty special stats end if below
END IF

NEXT

IF (temp1! MOD 2) <> 0 THEN PRINT #readstats%, "</TR>"
PRINT #readstats%, "</TABLE>"

END IF
REM ^^^ endif to see if stats needed at all
END IF

REM ------------------awards---------------

IF (flags% AND 64) > 0 THEN

PRINT #readstats%, "<HR WIDTH=100%>"
PRINT #readstats%, "<A NAME=awards></A>"
PRINT #readstats%, "<H2>Awards</H2>"

PRINT #readstats%, "<DT><FONT SIZE=-1>"
IF (flags% AND 16) = 16 THEN PRINT #readstats%, "I <A HREF=#ga>General Awards</A> "
IF (flags% AND 8) = 8 THEN PRINT #readstats%, "I <A HREF=#wa>Weapon Awards</A> "
IF (flags% AND 32) = 32 THEN PRINT #readstats%, "I <A HREF=#sa>Special filter Awards</A> "
PRINT #readstats%, "I</FONT><HR WIDTH=100%></DT>"

IF (flags% AND 16) > 0 THEN

PRINT #readstats%, "<A NAME=ga></A>"
PRINT #readstats%, "<H2>General Awards</H2>"
PRINT #readstats%, "<P>-</P>"

IF mstats(6) > 0 THEN

PRINT #readstats%, "<H3>Best overall player</H3>"
PRINT #readstats%, "<P>-</P>"
PRINT #readstats%, "<P>"; mstatsn(0); " with the rank of "; mstats(0); "</P>"
PRINT #readstats%, "<P>-</P>"


PRINT #readstats%, "<H3>Other general Statistics</H3>"
PRINT #readstats%, "<P>-</P>"

IF mostsucs% > 0 THEN
PRINT #readstats%, "<H4>The - This Ain't Real Life<FONT SIZE=-1><SUP>TM</SUP></FONT> U'Know - Award</H4>"
PRINT #readstats%, "<P>"; mostsuc$; ". Having a total disregard of life with "; mostsucs%; " suicide(s).</P>"
PRINT #readstats%, "<P>-</P>"
END IF

PRINT #readstats%, "<H4>Terminator Award</H4>"
PRINT #readstats%, "<P>"; mstatsn(2); " with a killing efficiency of "; mstats(2); "%.</P>"
PRINT #readstats%, "<P>-</P>"

PRINT #readstats%, "<H4>Slaughterhouse Award</H4>"
PRINT #readstats%, "<P>"; mstatsn(3); " with a total of "; mstats(3); " kills.</P>"
PRINT #readstats%, "<P>-</P>"

PRINT #readstats%, "<H4>Slaughterhouse Lamb Award</H4>"
PRINT #readstats%, "<P>"; mstatsn(6); " getting slaughtered a total of "; mstats(6); " time(s).</P>"
PRINT #readstats%, "<P>-</P>"

PRINT #readstats%, "<H4>Mr. McGoo Award</H4>"
PRINT #readstats%, "<P>"; mstatsn(4); " killing only "; mstats(4); " moving object(s).</P>"
PRINT #readstats%, "<P>-</P>"

PRINT #readstats%, "<H4>Sly Fox Award</H4>"
PRINT #readstats%, "<P>"; mstatsn(5); " getting killed only "; mstats(5); " time(s).</P>"
PRINT #readstats%, "<P>-</P>"

PRINT #readstats%, "<H4>Quake Newbie Award</H4>"
PRINT #readstats%, "<P>"; mstatsn(1); " with a killing rank of "; mstats(1); ".</P>"
PRINT #readstats%, "<HR WIDTH=100%>"

ELSE

PRINT #readstats%, "<P>Nobody killed anyone - you don't get any awards for that.</P>"

END IF
END IF
REM --------------------weapons awards------------

IF (flags% AND 8) > 0 THEN
temp1! = 0
FOR temp2! = 1 TO numweapons%
temp1! = temp1! + wstats(temp2!, 1)
NEXT

PRINT #readstats%, "<A NAME=wa></A>"

IF temp1! <> 0 THEN

PRINT #readstats%, "<H2>Individual Weapon Awards</H2>"

PRINT #readstats%, "<P>-</P>"
PRINT #readstats%, "<H3>Best Reaper of Lives</H3>"

PRINT #readstats%, "<TABLE BORDER=0 WIDTH=100%>"

PRINT #readstats%, "<TR>"
temp2! = 0
FOR temp1! = 1 TO numweapons%

IF wstats(temp1!, 0) <> 0 THEN

PRINT #readstats%, "<TD ALIGN=CENTER WIDTH=33%><FONT COLOR=#8080FF> " + weaponame(temp1!) + "</FONT>"
PRINT #readstats%, "<P>"; wstatsn(temp1!, 0); "</P>"
PRINT #readstats%, "<P>With "; wstats(temp1!, 0); " Kill(s).</P>"
PRINT #readstats%, "<P>-</P></TD>"
temp2! = temp2! + 1
END IF

IF (temp2! MOD 3) = 0 THEN PRINT #readstats%, "</TR><TR>"

NEXT
IF (temp2! MOD 3) <> 0 THEN PRINT #readstats%, "</TR>"
PRINT #readstats%, "</TABLE>"

REM ----------------------------

PRINT #readstats%, "<H3>Most Efficient Reaper of Lives</H3>"
PRINT #readstats%, "<TABLE BORDER=0 WIDTH=100%>"

PRINT #readstats%, "<TR>"

temp2! = 0
FOR temp1! = 1 TO numweapons%

IF wstats(temp1!, 3) <> 0 THEN

PRINT #readstats%, "<TD ALIGN=CENTER WIDTH=33%><FONT COLOR=#8080FF> " + weaponame(temp1!) + "</FONT>"
PRINT #readstats%, "<P>"; wstatsn(temp1!, 3); "</P>"
PRINT #readstats%, "<P>With "; wstats(temp1!, 3); "% Efficiency.</P>"
PRINT #readstats%, "<P>-</P></TD>"
temp2! = temp2! + 1
END IF

IF (temp2! MOD 3) = 0 THEN PRINT #readstats%, "</TR><TR>"

NEXT
IF (temp2! MOD 3) <> 0 THEN PRINT #readstats%, "</TR>"
PRINT #readstats%, "</TABLE>"

REM --------------------

temp2! = 0
FOR temp1! = 1 TO numweapons%
temp2! = temp2! + wstats(temp1!, 2)
NEXT
IF temp2! <> 0 THEN

PRINT #readstats%, "<H3>Best Reaper of Their Own Lives</H3>"
PRINT #readstats%, "<TABLE BORDER=0 WIDTH=100%>"

PRINT #readstats%, "<TR>"

temp2! = 0
FOR temp1! = 1 TO numweapons%

IF wstats(temp1!, 2) <> 0 THEN

PRINT #readstats%, "<TD ALIGN=CENTER WIDTH=33%><FONT COLOR=#8080FF> " + weaponame(temp1!) + "</FONT>"
PRINT #readstats%, "<P>"; wstatsn(temp1!, 2); "</P>"
PRINT #readstats%, "<P>With "; wstats(temp1!, 2); " Suicide(s).</P>"
PRINT #readstats%, "<P>-</P></TD>"
temp2! = temp2! + 1
END IF

IF (temp2! MOD 3) = 0 THEN PRINT #readstats%, "</TR><TR>"

NEXT
IF (temp2! MOD 3) <> 0 THEN PRINT #readstats%, "</TR>"
PRINT #readstats%, "</TABLE>"

END IF

REM -------------

PRINT #readstats%, "<H3>Who the Reaper Picks On</H3>"
PRINT #readstats%, "<TABLE BORDER=0 WIDTH=100%>"

PRINT #readstats%, "<TR>"

temp2! = 0
FOR temp1! = 1 TO numweapons%

IF wstats(temp1!, 1) <> 0 THEN

PRINT #readstats%, "<TD ALIGN=CENTER WIDTH=33%><FONT COLOR=#8080FF> " + weaponame(temp1!) + "</FONT>"
PRINT #readstats%, "<P>"; wstatsn(temp1!, 1); "</P>"
PRINT #readstats%, "<P>With "; wstats(temp1!, 1); " Death(s).</P>"
PRINT #readstats%, "<P>-</P></TD>"
temp2! = temp2! + 1
END IF

IF (temp2! MOD 3) = 0 THEN PRINT #readstats%, "</TR><TR>"

NEXT
IF (temp2! MOD 3) <> 0 THEN PRINT #readstats%, "</TR>"
PRINT #readstats%, "</TABLE>"
PRINT #readstats%, "<HR WIDTH=100%>"
END IF
END IF

REM ---------special awards---------

IF (flags% AND 32) > 0 THEN

temp1! = 0
FOR temp2! = 0 TO numtypesp% - 1
temp1! = temp1! + sstats(temp2!)
NEXT
PRINT #readstats%, "<A NAME=sa></A>"

IF temp1! > 0 THEN

PRINT #readstats%, "<H2>Special Filter Awards</H2>"

PRINT #readstats%, "<TABLE BORDER=0 WIDTH=100%>"

PRINT #readstats%, "<TR>"

temp2! = 0
FOR temp1! = 0 TO numtypesp% - 1

IF sstats(temp1!) <> 0 THEN

PRINT #readstats%, "<TD ALIGN=CENTER WIDTH=33%><FONT COLOR=#8080FF> " + spname(temp1!) + "</FONT>"
PRINT #readstats%, "<P>"; sstatsn(temp1!); "</P>"
PRINT #readstats%, "<P>With a score of "; sstats(temp1!); ".</P>"
PRINT #readstats%, "<P>-</P></TD>"
temp2! = temp2! + 1
END IF

IF (temp2! MOD 3) = 0 THEN PRINT #readstats%, "</TR><TR>"

NEXT
IF (temp2! MOD 3) <> 0 THEN PRINT #readstats%, "</TR>"
PRINT #readstats%, "</TABLE>"

END IF
REM ^^^ end if of test to see wether we should do awards

END IF

REM ^^^ end of special awards

END IF

REM ---------end of awards----------

CALL htmlfooter

END IF

REM ------------end of dump--------


PRINT #readstats%, "</BODY>"
PRINT #readstats%, "</HTML>"

END SUB

FUNCTION getfilename$ (line$)
count = 1
DO WHILE (MID$(line$, (LEN(line$) - count) + 1, 1) <> "\") AND (count < LEN(line$))
count = count + 1
LOOP
IF count <> LEN(line$) THEN count = count - 1
filename$ = MID$(line$, LEN(line$) - count + 1)
IF UCASE$(filename$) = "QCONSOLE.LOG" THEN
filename$ = "level"
ELSE

IF INSTR(filename$, ".") THEN filename$ = LEFT$(filename$, INSTR(filename$, ".") - 1)
IF LEN(filename$) > 5 THEN filename$ = LEFT$(filename$, 5)

IF count > 12 OR LEN(filename$) < 1 THEN filename$ = ""
END IF

getfilename = filename$

END FUNCTION

FUNCTION GetPlayer (pname$) STATIC

REM These varibles are buffers, to speed things up

temp2% = 0

IF pname$ = last1$ THEN temp2% = last1%
IF pname$ = last2$ THEN temp2% = last2%
IF pname$ = last3$ THEN temp2% = last3%
IF pname$ = last4$ THEN temp2% = last4%
IF pname$ = last5$ THEN temp2% = last5%
IF pname$ = last6$ THEN temp2% = last6%

IF temp2% = 0 THEN

TempPlayer.Handle = pname$
TempPlayer.Kills = 0
TempPlayer.deaths = 0
TempPlayer.Skill = 1000
TempPlayer.LastSeen = days!


GET #playerdata%, 1, FileBuffer
temp1% = FALSE
temp2% = 1
DO WHILE (NOT EOF(playerdata%)) AND temp1% = FALSE

IF FileBuffer.Handle = TempPlayer.Handle THEN
temp1% = TRUE

ELSE
temp2% = temp2% + 1
GET #playerdata%, temp2%, FileBuffer

END IF

LOOP

IF temp1% = FALSE THEN

REM ----new player------

PUT #playerdata%, temp2%, TempPlayer
END IF

IF last1$ = "" THEN
last1% = temp2%: last1$ = pname$
ELSE
    IF last2$ = "" THEN
    last2% = temp2%: last2$ = pname$
    ELSE
        IF last3$ = "" THEN
        last3% = temp2%: last3$ = pname$
        ELSE
            IF last4$ = "" THEN
            last4% = temp2%: last4$ = pname$
            ELSE
                IF last5$ = "" THEN
                last5% = temp2%: last5$ = pname$
                ELSE
                    IF last6$ = "" THEN
                    last6% = temp2%: last6$ = pname$
                    ELSE
                        last6$ = last5$
                        last5$ = last4$
                        last4$ = last3$
                        last3$ = last2$
                        last2$ = last1$
                       
                        last1$ = pname$
          
                        last6% = last5%
                        last5% = last4%
                        last4% = last3%
                        last3% = last2%
                        last2% = last1%
                       
                        last1% = temp2%
                    END IF
                END IF
            END IF
        END IF
    END IF
END IF


END IF

' ^^^ test for buffer endif


GetPlayer = temp2%

END FUNCTION

DEFSNG A-Z
SUB htmlfooter

PRINT #readstats%, "<HR WIDTH=100%>"
IF (clevel%) = tlevel% THEN
IF tlevel% = 1 THEN prev$ = ofname$ + "1.htm" ELSE prev$ = ofname$ + RIGHT$(STR$(clevel% - 1), LEN(STR$(clevel% - 1)) - 1) + ".htm"
next$ = ofname$ + "1.htm"
ELSE
IF (clevel%) = 1 THEN
next$ = ofname$ + "2.htm"
prev$ = ofname$ + RIGHT$(STR$(tlevel%), LEN(STR$(tlevel%)) - 1) + ".htm"
ELSE
next$ = ofname$ + RIGHT$(STR$(clevel% + 1), LEN(STR$(clevel% + 1)) - 1) + ".htm"
prev$ = ofname$ + RIGHT$(STR$(clevel% - 1), LEN(STR$(clevel% - 1)) - 1) + ".htm"
END IF
END IF

PRINT #readstats%, "<CENTER><DT>I <A HREF="; prev$; ">Previous</A> I <A HREF="; next$; ">Next</A>"
PRINT #readstats%, " I</DT></CENTER>"

PRINT #readstats%, "<CENTER><DT><FONT SIZE=-2>I"

FOR i = 1 TO tlevel%
PRINT #readstats%, "<A HREF="; ofname$; RIGHT$(STR$(i), LEN(STR$(i)) - 1); ".htm>"; RIGHT$(STR$(i), LEN(STR$(i)) - 1); "</A> I"
NEXT
PRINT #readstats%, "</FONT></DT></CENTER>"

PRINT #readstats%, "<CENTER><DT><FONT SIZE=-1>"
IF (flags% AND 4) = 4 THEN PRINT #readstats%, "I <A HREF=#speech>Speech</A> "
PRINT #readstats%, "I <A HREF=#players>Players</A> "
IF (flags% AND 512) = 512 THEN PRINT #readstats%, "I <A HREF=#showline>Important Messages</A> "
IF (flags% AND 16) = 16 THEN PRINT #readstats%, "I <A HREF=#total>Level Stats</A> "
IF (flags% AND 128) = 128 THEN PRINT #readstats%, "I <A HREF=#rankings>Rankings</A> "
IF (flags% AND 8) = 8 THEN PRINT #readstats%, "I <A HREF=#weapon>Weapon Stats</A> "
IF (flags% AND 32) = 32 THEN PRINT #readstats%, "I <A HREF=#special>Special filter Stats</A> "
IF (flags% AND 64) = 64 THEN PRINT #readstats%, "I <A HREF=#awards>Special Awards</A> "

PRINT #readstats%, "I"

END SUB

SUB htmlheader

PRINT #readstats%, "<!DOCTYPE HTML PUBLIC " + CHR$(34) + "-//W3C//DTD HTML 3.2//EN" + CHR$(34) + ">"
PRINT #readstats%, "<HTML>"
PRINT #readstats%, "<TITLE>Quake Console Statistics - By Richard Maxwell - Level "; clevel% + 1; " - "; leveln(clevel%); "</TITLE>"
PRINT #readstats%, "<META NAME=" + CHR$(34) + "Author" + CHR$(34) + " CONTENT=" + CHR$(34) + "Richard Maxwell" + CHR$(34) + ">"
PRINT #readstats%, "<META NAME=" + CHR$(34) + "GENERATOR" + CHR$(34) + " CONTENT=" + CHR$(34) + "Mozilla/3.01Gold (Win95; I) [Netscape]" + CHR$(34) + ">"
PRINT #readstats%, "<META NAME=" + CHR$(34) + "Description" + CHR$(34) + "CONTENT =" + CHR$(34) + "Quake console statistics. The generator of this HTML is done by Richard Maxwell" + CHR$(34) + ">"
PRINT #readstats%, "</HEAD>"
REM PRINT #readstats%, "<BODY TEXT=#C0C0C0 BGCOLOR=#000000 LINK=#8080FF VLINK=#0000FF ALINK=#FF0000>"
PRINT #readstats%, bodytag$


PRINT #readstats%, "<H1 ALIGN=CENTER><FONT SIZE=+3>"; leveln$(clevel%); "</FONT></H1>"

IF (clevel% + 1) = tlevel% THEN
IF tlevel% = 1 THEN prev$ = ofname$ + "1.htm" ELSE prev$ = ofname$ + RIGHT$(STR$(clevel%), LEN(STR$(clevel%)) - 1) + ".htm"
next$ = ofname$ + "1.htm"
ELSE
IF (clevel% + 1) = 1 THEN
next$ = ofname$ + "2.htm"
prev$ = ofname$ + RIGHT$(STR$(tlevel%), LEN(STR$(tlevel%)) - 1) + ".htm"
ELSE
next$ = ofname$ + RIGHT$(STR$(clevel% + 2), LEN(STR$(clevel% + 2)) - 1) + ".htm"
prev$ = ofname$ + RIGHT$(STR$(clevel%), LEN(STR$(clevel%)) - 1) + ".htm"
END IF
END IF

PRINT #readstats%, "<CENTER><DT>I <A HREF="; prev$; ">Previous</A> I <A HREF="; next$; ">Next</A>"
PRINT #readstats%, " I</DT></CENTER>"

PRINT #readstats%, "<CENTER><DT><FONT SIZE=-2>I"

FOR i = 1 TO tlevel%
PRINT #readstats%, "<A HREF="; ofname$; RIGHT$(STR$(i), LEN(STR$(i)) - 1); ".htm>"; RIGHT$(STR$(i), LEN(STR$(i)) - 1); "</A> I"
NEXT
PRINT #readstats%, "</FONT></DT></CENTER>"

PRINT #readstats%, "<CENTER><DT><FONT SIZE=-1>"
IF (flags% AND 4) = 4 THEN PRINT #readstats%, "I <A HREF=#speech>Speech</A> "
PRINT #readstats%, "I <A HREF=#players>Players</A> "
IF (flags% AND 512) = 512 THEN PRINT #readstats%, "I <A HREF=#showline>Important Messages</A> "
IF (flags% AND 16) = 16 THEN PRINT #readstats%, "I <A HREF=#total>Level Stats</A> "
IF (flags% AND 128) = 128 THEN PRINT #readstats%, "I <A HREF=#rankings>Rankings</A> "
IF (flags% AND 8) = 8 THEN PRINT #readstats%, "I <A HREF=#weapon>Weapon Stats</A> "
IF (flags% AND 32) = 32 THEN PRINT #readstats%, "I <A HREF=#special>Special filter Stats</A> "
IF (flags% AND 64) = 64 THEN PRINT #readstats%, "I <A HREF=#awards>Special Awards</A> "

PRINT #readstats%, "I</FONT></CENTER></DT>"


PRINT #readstats%, "<HR WIDTH=100%><A NAME=speech></A>"

IF (flags% AND 4) > 0 THEN PRINT #readstats%, "<H2 ALIGN=CENTER>Speech</H2>"

PRINT #readstats%, "<PRE>"

END SUB

FUNCTION htmlString$ (name$)

outstring$ = ""
dotstring$ = CHR$(133) + CHR$(143) + CHR$(142) + CHR$(156)
hashstring$ = CHR$(131) + CHR$(132) + CHR$(134) + CHR$(135) + CHR$(136) + CHR$(137)
spaces$ = CHR$(138) + CHR$(140) + CHR$(160)

FOR i = 1 TO LEN(name$)
sorted = FALSE
char$ = MID$(name$, i, 1)
achar = ASC(char$)
IF achar > 31 THEN
IF achar < 128 THEN outstring$ = outstring$ + char$: sorted = TRUE
IF sorted = FALSE AND INSTR(hashstring$, char$) > 0 THEN outstring$ = outstring$ + "<FONT COLOR=#800000>#</FONT>": sorted = TRUE
IF sorted = FALSE AND INSTR(dotstring$, char$) > 0 THEN outstring$ = outstring$ + "<FONT COLOR=#FFFF00>.</FONT>": sorted = TRUE
IF sorted = FALSE AND achar > 145 AND achar < 156 THEN outstring$ = outstring$ + "<FONT COLOR=#804000>" + CHR$(ASC(char$) - 98) + "</FONT>": sorted = TRUE


IF sorted = FALSE AND (achar = 157 OR achar = 159) THEN outstring$ = outstring$ + "<FONT COLOR=#800000>-</FONT>": sorted = TRUE

IF sorted = FALSE AND achar = 128 THEN outstring$ = outstring$ + "<B><FONT COLOR=#FF8000>(</FONT></B>": sorted = TRUE
IF sorted = FALSE AND achar = 129 THEN outstring$ = outstring$ + "<B><FONT COLOR=#FF8000>=</FONT></B>": sorted = TRUE
IF sorted = FALSE AND achar = 130 THEN outstring$ = outstring$ + "<B><FONT COLOR=#FF8000>)</FONT></B>": sorted = TRUE
IF sorted = FALSE AND achar = 139 THEN outstring$ = outstring$ + "<FONT COLOR=#FF8000>#</FONT>": sorted = TRUE
IF sorted = FALSE AND achar = 158 THEN outstring$ = outstring$ + "<FONT COLOR=#800000>=</FONT>": sorted = TRUE
IF sorted = FALSE AND achar = 141 THEN outstring$ = outstring$ + "<FONT COLOR=#FF0000>></FONT>": sorted = TRUE
IF sorted = FALSE AND achar = 144 THEN outstring$ = outstring$ + "<FONT COLOR=#FF8000>[</FONT>": sorted = TRUE
IF sorted = FALSE AND achar = 145 THEN outstring$ = outstring$ + "<FONT COLOR=#FF8000>]</FONT>": sorted = TRUE
IF sorted = FALSE AND INSTR(spaces$, char$) > 0 THEN outstring$ = outstring$ + " ": sorted = TRUE

IF sorted = FALSE THEN outstring$ = outstring$ + "<FONT COLOR=#FF8000>" + CHR$(ASC(char$) - 128) + "</FONT>": sorted = TRUE
ELSE
IF achar > 17 AND achar < 27 THEN outstring$ = outstring$ + "<FONT COLOR=#804000>" + CHR$(ASC(char$) + 40) + "</FONT>": sorted = TRUE
IF sorted = FALSE AND achar > 1 AND achar < 5 THEN outstring$ = outstring$ + "<FONT COLOR=#800000>#</FONT>": sorted = TRUE
IF sorted = FALSE AND achar > 5 AND achar < 10 THEN outstring$ = outstring$ + "<FONT COLOR=#800000>#</FONT>": sorted = TRUE


IF sorted = FALSE AND achar = 11 THEN outstring$ = outstring$ + "<FONT COLOR=#FFFFFF>#</FONT>": sorted = TRUE
IF sorted = FALSE AND achar = 16 THEN outstring$ = outstring$ + "<FONT COLOR=#FF8000>[</FONT>": sorted = TRUE
IF sorted = FALSE AND achar = 17 THEN outstring$ = outstring$ + "<FONT COLOR=#FF8000>]</FONT>": sorted = TRUE
IF sorted = FALSE AND (achar = 29 OR achar = 31) THEN outstring$ = outstring$ + "<FONT COLOR=#800000>-</FONT>": sorted = TRUE
IF sorted = FALSE AND achar = 30 THEN outstring$ = outstring$ + "<FONT COLOR=#800000>=</FONT>": sorted = TRUE

END IF
IF sorted = FALSE THEN outstring$ = outstring$ + " "

NEXT

htmlString = outstring$
END FUNCTION

DEFINT A-Z
FUNCTION isEnter (qline$)
place = INSTR(qline$, " entered the game")
IF place THEN place = WhichPlayer(LEFT$(qline$, place - 1))

isEnter = place


END FUNCTION

FUNCTION isLevel (qline$)


readok = FALSE


IF INSTR(qline$, STRING$(10, CHR$(30))) > 1 THEN

DO WHILE NOT (EOF(1) OR readok = TRUE)

LINE INPUT #1, qline$

IF LEFT$(qline$, 1) = CHR$(2) THEN readok = TRUE

LOOP

IF readok = TRUE THEN

clevel% = clevel% + 1


IF readstats% = 0 THEN

leveln(clevel%) = RIGHT$(qline$, LEN(qline$) - 1)
IF clevel% THEN levelp(clevel% - 1) = pfound%
pfound% = 0
END IF
END IF


END IF

isLevel = readok

END FUNCTION

FUNCTION isPing$ (qline$)

numstr$ = "0123456789"

IF INSTR(qline$, "Client ping times:") > 0 THEN
LINE INPUT #1, qline$

DO WHILE (LEFT$(qline$, 1) = " " OR INSTR(numstr$, LEFT$(qline$, 1)) > 0) AND NOT EOF(1)

DO WHILE LEFT$(qline$, 1) = " "
qline$ = MID$(qline$, 2)
LOOP

secspace% = INSTR(qline$, " ")


IF secspace% > 0 AND INSTR(LEFT$(qline$, secspace%), "k") = 0 AND INSTR(LEFT$(qline$, secspace%), "x") = 0 THEN

name$ = MID$(qline$, secspace% + 1)
player% = WhichPlayer(name$)

IF readstats% > 0 AND player% > 0 THEN
players(player%, 1) = players(player%, 1) + VAL(LEFT$(qline$, secspace% - 1))
players(player%, 2) = players(player%, 2) + 1

END IF
END IF

LINE INPUT #1, qline$
LOOP

END IF
isPing = qline$

END FUNCTION

FUNCTION istalking (qline$) STATIC

IF ASC(LEFT$(qline$, 1)) = 1 THEN
IF NOT (laststr$ = qline$ AND (flags% AND 1) > 0) THEN
IF readstats% AND (flags% AND 4) > 0 THEN PRINT #readstats%, htmlString(RIGHT$(qline$, LEN(qline$) - 1))
laststr$ = qline$
END IF
istalking = TRUE
ELSE
istalking = FALSE
END IF


END FUNCTION

FUNCTION qwistalking (qline$) STATIC

temp = INSTR(qline$, ": ")


IF temp <> 0 AND temp < 23 THEN
IF NOT (laststr$ = qline$ AND (flags% AND 1) > 0) THEN
IF readstats% AND (flags% AND 4) > 0 THEN PRINT #readstats%, htmlString(qline$)
laststr$ = qline$
END IF
qwistalking = TRUE
ELSE
qwistalking = FALSE
END IF

END FUNCTION

DEFSNG A-Z
SUB readIni

OPEN "conread.ini" FOR INPUT AS #1

rline$ = ""

REM -----------------weapons------------------

DO WHILE (NOT EOF(1)) AND INSTR(rline$, "****weapons") = 0

LINE INPUT #1, rline$

LOOP

count = 1

DO WHILE INSTR(rline$, "*****") = 0

LINE INPUT #1, rline$
IF LEFT$(rline$, 5) = "-----" THEN weaponame(count) = MID$(rline$, 6): count = count + 1
LOOP

REM --------------------suicide filters----------------

DO WHILE INSTR(rline$, "****sucs") = 0

LINE INPUT #1, rline$

LOOP

count = 0
sucount = 1

DO WHILE INSTR(rline$, "*****") = 0

LINE INPUT #1, rline$

IF INSTR(rline$, "-----") > 0 AND INSTR(rline$, "#") = 0 THEN
sucount = sucount + 1
ELSE

IF rline$ = "" OR LEFT$(rline$, 1) = "#" OR rline$ = "*****" THEN
ELSE
sucfilters(count) = rline$
sucfilterw(count) = sucount
count = count + 1
END IF
END IF

LOOP

REM ----------------death filters-------------
       
DO WHILE INSTR(rline$, "****deaths") = 0

LINE INPUT #1, rline$

LOOP

count = 0
decount = 1

DO WHILE INSTR(rline$, "*****") = 0

INPUT #1, rline$

IF INSTR(rline$, "-----") > 0 THEN
decount = decount + 1
ELSE

IF rline$ = "" OR LEFT$(rline$, 1) = "#" OR rline$ = "*****" THEN
ELSE

IF LEFT$(rline$, 7) = "REVERSE" THEN        'checking to see if we have to revese the killer/killee

    dfilterm(count) = MID$(rline$, 8)
    dfilterw(count) = decount
    dfilterr(count) = TRUE

ELSE

    dfilterm(count) = rline$
    dfilterw(count) = decount
    dfilterr(count) = FALSE

END IF

INPUT #1, rline$
dfiltere(count) = rline$
count = count + 1

END IF
END IF

LOOP

REM -------------special filters------------

IF (flags% AND 32) = 32 THEN

DO WHILE (NOT EOF(1)) AND INSTR(rline$, "****special") = 0

LINE INPUT #1, rline$

LOOP

count = 0
spcount = -1

DO WHILE (NOT EOF(1)) AND INSTR(rline$, "*****") = 0

INPUT #1, rline$

IF INSTR(rline$, "-----") > 0 AND INSTR(rline$, "#") = 0 THEN
spcount = spcount + 1
spname(spcount) = MID$(rline$, INSTR(rline$, "-----") + 5)
ELSE

IF rline$ = "" OR LEFT$(rline$, 1) = "#" OR rline$ = "*****" THEN
ELSE
spfilters(count) = rline$
spfilterw(count) = spcount
count = count + 1
END IF
END IF

LOOP
END IF

REM -------------showline filters------------

IF (flags% AND 512) = 512 THEN

DO WHILE (NOT EOF(1)) AND INSTR(rline$, "****showline") = 0

LINE INPUT #1, rline$

LOOP

count = 0

DO WHILE (NOT EOF(1)) AND INSTR(rline$, "*****") = 0

INPUT #1, rline$

IF rline$ = "" OR LEFT$(rline$, 1) = "#" OR rline$ = "*****" THEN
ELSE
slfilters(count) = rline$
count = count + 1
END IF

LOOP
END IF

REM -------------body tag------------

DO WHILE (NOT EOF(1)) AND INSTR(rline$, "****bodytag") = 0

LINE INPUT #1, rline$

LOOP

DO WHILE (NOT EOF(1)) AND INSTR(rline$, "*****") = 0
INPUT #1, rline$
IF rline$ = "" OR LEFT$(rline$, 1) = "#" OR rline$ = "*****" THEN
ELSE
bodytag$ = rline$
END IF
LOOP

IF LEFT$(bodytag$, 5) <> "<BODY" THEN bodytag$ = "<BODY TEXT=#C0C0C0 BGCOLOR=#000000 LINK=#8080FF VLINK=#0000FF ALINK=#FF0000>"

CLOSE #1

IF (flags% AND 56) = 0 THEN flags% = (flags% AND 65471)

END SUB

DEFINT A-Z
FUNCTION testDeath (qline$)

reverse = FALSE

count = -1
player = FALSE
DO WHILE (count < (numfilter(1) - 1)) AND (player = FALSE)
count = count + 1

IF dfiltere(count) = "" THEN
place1 = INSTR(qline$, dfilterm(count))
place2 = -1

ELSE
place1 = INSTR(qline$, dfilterm(count))
place2 = INSTR(qline$, dfiltere(count))


END IF

IF place1 > 0 AND place2 <> 0 THEN player = TRUE

LOOP

IF player = TRUE THEN

IF place2 = -1 THEN

killee = WhichPlayer(LEFT$(qline$, place1 - 1))
killer = WhichPlayer(RIGHT$(qline$, LEN(qline$) - (place1 + LEN(dfilterm(count)) - 1)))


ELSE

killee = WhichPlayer(LEFT$(qline$, place1 - 1))
killer = WhichPlayer(MID$(qline$, place1 + LEN(dfilterm(count)), place2 - (place1 + LEN(dfilterm(count)))))

END IF
END IF

IF killer > 0 AND killee > 0 AND readstats% > 0 THEN

IF dfilterr(count) = TRUE THEN          'if reverse kill kilter, revers killer/killee
    reverse = killer
    killer = killee
    killee = reverse
END IF

IF (flags% AND 256) > 0 THEN CALL UpdatePlayer(playern(killer, 0), playern(killee, 0))

playstat(killer, dfilterw(count), killee) = playstat(killer, dfilterw(count), killee) + 1

END IF

IF killer = 0 OR killee = 0 THEN player = FALSE

testDeath = player


END FUNCTION

FUNCTION testShowLine (qline$)

found = 0

DO WHILE ((found < numslfilters%) AND (INSTR(qline$, slfilters(found)) = 0))
found = found + 1           ' very tempted to say "found++"
LOOP

IF found = numslfilters% THEN
found = FALSE
ELSE
PRINT #showline%, qline$
found = TRUE
END IF

testShowLine = found

END FUNCTION

FUNCTION testSpecial (qline$)

count = -1
player = FALSE
DO WHILE (count < (numfilter(2) - 1)) AND (player < 1)
count = count + 1
place = INSTR(qline$, spfilters(count))

REM PRINT "qline :"; qline$; ": compair :"; spfilters(count); ":": INPUT x

IF place THEN player = WhichPlayer(LEFT$(qline$, place - 1))
LOOP

IF player > 0 AND readstats% > 0 THEN

playspec(player, spfilterw(count)) = playspec(player, spfilterw(count)) + 1

END IF

testSpecial = player

END FUNCTION

FUNCTION testSuc (qline$)

count = -1
player = FALSE
DO WHILE (count < (numfilter(0) - 1)) AND (player < 1)
count = count + 1
place = INSTR(qline$, sucfilters(count))

IF place THEN player = WhichPlayer(LEFT$(qline$, place - 1))
LOOP



IF player > 0 AND readstats% > 0 THEN

IF (flags% AND 256) > 0 THEN CALL UpdatePlayer(playern(player, 0), playern(player, 0))

IF sucfilterw(count) > numweapons% THEN
players(player, 0) = players(player, 0) + 1

ELSE

playstat(player, sucfilterw(count), player) = playstat(player, sucfilterw(count), player) + 1
END IF
END IF

testSuc = player


END FUNCTION

DEFSNG A-Z
SUB UpdatePlayer (killer$, killee$)

IF killer$ = killee$ THEN

killernum = GetPlayer(killer$)
GET #playerdata%, killernum, Player1

Player1.Kills = Player1.Kills + 1
Player1.deaths = Player1.deaths + 1
Player1.Skill = Player1.Skill - CINT(Player1.Skill / 200)
IF Player1.Skill < 1000 THEN Player1.Skill = 1000
Player1.LastSeen = days!
PUT #playerdata%, killernum, Player1

ELSE
killernum = GetPlayer(killer$)
killeenum = GetPlayer(killee$)
GET #playerdata%, killernum, Player1
GET #playerdata%, killeenum, Player2
Player1.Kills = Player1.Kills + 1
Player2.deaths = Player2.deaths + 1
Player1.Skill = Player1.Skill + CINT(Player2.Skill / 200)
Player2.Skill = Player2.Skill - CINT(Player2.Skill / 200)
IF Player2.Skill < 1000 THEN Player2.Skill = 1000
Player1.LastSeen = days!
Player2.LastSeen = days!
PUT #playerdata%, killernum, Player1
PUT #playerdata%, killeenum, Player2
END IF

END SUB

DEFINT A-Z
FUNCTION WhichPlayer (test$)

playernum = 0

IF NOT (test$ = "") THEN

FOR count = 1 TO pfound%
IF test$ = playern(count, 0) THEN playernum = count: EXIT FOR
NEXT

IF NOT (playernum > 0 OR pfound% >= maxplayer%) THEN
pfound% = pfound% + 1
playernum = pfound%
playern(pfound%, 0) = test$
playern(pfound%, 1) = htmlString(test$)

END IF
END IF

WhichPlayer = playernum

END FUNCTION

